---
title: Range.cloneContents()
slug: Web/API/Range/cloneContents
tags:
  - API
  - DOM
  - Method
  - Range
---
<p>{{ APIRef("DOM") }}</p>

<p>The <strong><code>Range.cloneContents()</code></strong> returns a {{ domxref("DocumentFragment") }} copying the objects of type {{ domxref("Node") }} included in the {{ domxref("Range") }}.</p>

<p>Event Listeners added using DOM Events are not copied during cloning. HTML attribute events are duplicated as they are for the DOM Core cloneNode method. HTML id attributes are also cloned, which can lead to an invalid document through cloning.</p>

<p>Partially selected nodes include the parent tags necessary to make the document fragment valid.</p>

<h2 id="Syntax">Syntax</h2>

<pre class="syntaxbox"><em>documentFragment </em>= <em>range</em>.cloneContents();
</pre>

<h2 id="Example">Example</h2>

<pre class="brush: js">range = document.createRange();
range.selectNode(document.getElementsByTagName("div").item(0));
documentFragment = range.cloneContents();
document.body.appendChild(documentFragment);
</pre>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <tbody>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
  <tr>
   <td>{{SpecName('DOM WHATWG', '#dom-range-clonecontents', 'Range.cloneContents()')}}</td>
   <td>{{Spec2('DOM WHATWG')}}</td>
   <td>No change.</td>
  </tr>
  <tr>
   <td>{{SpecName('DOM2 Traversal_Range', 'ranges.html#Level2-Range-method-cloneContents', 'Range.cloneContents()')}}</td>
   <td>{{Spec2('DOM2 Traversal_Range')}}</td>
   <td>Initial specification.</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<p>{{Compat("api.Range.cloneContents")}}</p>

<h2 id="See_also">See also</h2>

<ul>
 <li><a href="/en-US/docs/DOM/DOM_Reference">The DOM interfaces index</a></li>
</ul>
